import {
    DEFAULT_NAMETAG_COLOR, 
    NAMETAG_COLOR_PREFIX
} from "./Config/NameColorConfig.js";
import {
    DEFAULT_CHAT_COLOR, 
    CHAT_COLOR_PREFIX
} from "./Config/MessageColorConfig.js";
import {
  COLORS
} from "../Colors/ColorsConstant.js";

export function getChatColor(player, type) {
    
    switch (type) {
      case 'nameTag':
        try {
          let nameTagTag = player.getTags().find((tag) => tag.startsWith(NAMETAG_COLOR_PREFIX))
          if (COLORS.includes(nameTagTag.replace(NAMETAG_COLOR_PREFIX,''))) {
            switch (nameTagTag.replace(NAMETAG_COLOR_PREFIX,'')) {
              case 'black':
                return '§0'
                break;
              case 'darkBlue':
                return '§1'
                break;
              case 'darkGreen':
                return '§2'
                break;
              case 'darkAqua':
                return '§3'
                break;
              case 'darkRed':
                return '§4'
                break;
              case 'darkPurple':
                return '§5'
                break;
              case 'gold':
                return '§6'
                break;
              case 'gray':
                return '§7'
                break;
              case 'darkGray':
                return '§8'
                break;
              case 'blue':
                return '§9'
                break;
              case 'green':
                return '§a'
                break;
              case 'aqua':
                return '§b'
                break;
              case 'red':
                return '§c'
                break;
              case 'lightPurple':
                return '§d'
                break;
              case 'yellow':
                return '§e'
                break;
              case 'white':
                return '§f'
                break;
              case 'minecoinGold':
                return '§g'
                break;
              default:
                let index = nameTagTag.replace(CHAT_COLOR_PREFIX,'').indexOf('§')
                return nameTagTag.replace(CHAT_COLOR_PREFIX,'')[index] + nameTagTag.replace(CHAT_COLOR_PREFIX,'')[index + 1]
                break;
            }
          }
          else {
            return DEFAULT_NAMETAG_COLOR
          }
        } catch (error) {
          return DEFAULT_NAMETAG_COLOR
        }
        break;
      case 'chatMessage':
        try {
          let chatColorTag = player.getTags().find((tag) => tag.startsWith(CHAT_COLOR_PREFIX))
          if (COLORS.includes(chatColorTag.replace(CHAT_COLOR_PREFIX,''))) {
            switch (chatColorTag.replace(CHAT_COLOR_PREFIX,'')) {
              case 'black':
                return '§0'
                break;
              case 'darkBlue':
                return '§1'
                break;
              case 'darkGreen':
                return '§2'
                break;
              case 'darkAqua':
                return '§3'
                break;
              case 'darkRed':
                return '§4'
                break;
              case 'darkPurple':
                return '§5'
                break;
              case 'gold':
                return '§6'
                break;
              case 'gray':
                return '§7'
                break;
              case 'darkGray':
                return '§8'
                break;
              case 'blue':
                return '§9'
                break;
              case 'green':
                return '§a'
                break;
              case 'aqua':
                return '§b'
                break;
              case 'red':
                return '§c'
                break;
              case 'lightPurple':
                return '§d'
                break;
              case 'yellow':
                return '§e'
                break;
              case 'white':
                return '§f'
                break;
              case 'minecoinGold':
                return '§g'
                break;
    
              default:
                let index = chatColorTag.replace(CHAT_COLOR_PREFIX,'').indexOf('§')
                return chatColorTag.replace(CHAT_COLOR_PREFIX,'')[index] + chatColorTag.replace(CHAT_COLOR_PREFIX,'')[index + 1]
                break;
            }
          }
          else {
            return DEFAULT_CHAT_COLOR
          }
        } catch (error) {
          return DEFAULT_CHAT_COLOR
        }
        break;
    }
  }