import {
    DEFAULT_RANK,
    RANK_PREFIX,
    RANK_JOIN
} from "./Config.js"

export function getRank(player) {
    try {
        let ranks = player.getTags()
        let ranksArray = []
        for (let i = 0; i <= ranks.length - 1; i++) {
            if (ranks[i].startsWith(RANK_PREFIX)) {
                ranksArray.push(ranks[i].replace(RANK_PREFIX, '') + '§r')
            }
        }
        if (ranksArray.length == 0) {
            return DEFAULT_RANK
        }
        else {
            return ranksArray.join(RANK_JOIN)
        }
    }
    catch (error) {
        player.runCommand("say "+error.toString);
    }
}