import {
	MinecraftEnchantmentTypes,
	InventoryComponentContainer,
	EnchantmentList,
	EntityQueryOptions,
	BlockLocation,
	ItemStack,
	Items,
	Location,
	Entity,
	world,
	MinecraftBlockTypes,
	Player,
	system,
	BeforeItemUseEvent,
	BlockRaycastOptions,
	BlockPermutation,
	ScoreboardIdentity,
	EntityAgeableComponent,
	BeforeItemUseOnEvent,
	ChatEvent,
	TicksPerSecond,
	EntityMovementSkipComponent
} from "@minecraft/server";
import {
	ActionFormData,
	MessageFormData,
	ModalFormData
} from "@minecraft/server-ui";

import { COOLDOWNS } from "./Chat/SmellyCoolDown/cooldown.js"
import Cooldown from "./Chat/SmellyCoolDown/cooldown.js"
import { getChatColor } from "./Chat/NameMessageColor/NameMessageColor.js";

const commandPrefix = "+"

function tellraw(selector, text) {
	if (selector == undefined) {
		tellraw("@a", "§cPas de sélecteurs !");
	}
	else if (!selector.match(/@/g)) {
		runCommandAsync(`tellraw "${selector}" {"rawtext":[{"text":"§r${text.replace(/"/g, "\'")}"}]}`);
	}
	else {
		runCommandAsync(`tellraw ${selector} {"rawtext":[{"text":"§r${text.replace(/"/g, "\'")}"}]}`);
	}
}

function runCommandAsync(command) {
	try {
		return { error: false, ...world.getDimension(`overworld`).runCommandAsync(command) };
	} catch (error) {
		return { error: true };
	}
}

function setTickTimeout(callback, tick) {                                       //permet de gèrer les délais de ticks
	let ticks = 0
	let TickCallBack = world.events.tick.subscribe(() => {
		ticks += 1
		if (ticks == tick) {
			callback()
			world.events.tick.unsubscribe(TickCallBack)
		}
	})
}

world.events.beforeChat.subscribe(data => {
	data.cancel = true
    let player = data.sender
	if (data.message.startsWith(commandPrefix)) {
        const args = data.message.slice(commandPrefix.length).split(/\s+/g)
		data.cancel = true
		try {
            if (args[0] == "spec") {
				tellraw(`${player.name}`, "§8[§4Staff Plugin§8] §7>> §aClose your chat for see the menu ! It will open in 2 seconds")
                runCommandAsync(`playsound note.bass "${player.name}"`)
				setTickTimeout(() => {
					tellraw(`${player.name}`, "§8[§4Staff Plugin§8] §7>> §7Authors §f: §9PF KiLLeRZz#8328 §8/ §7Texturing §f: §9! XerFox#8871")
				}, 20)
                setTickTimeout(() => {
                    Ainventory(player)
				 },30)
			}
		}  catch (error) {
			log(`${error} : ${error.stack}`);
		}
	} else {
	if (player.hasTag('mute')) {
		player.runCommandAsync(`tellraw @s { "rawtext": [{ "text": "§7[§r§4Staff Plugin§7]§r§7 Mute §7§l>§r §cYou have been muted!" }] }`)
	} else {
		const cooldown = COOLDOWNS[player.nameTag];
		if (cooldown) return cooldown.reply(player);
		new Cooldown(player.nameTag);
		if (player.hasTag('OP')) {
			tellraw("@a", `§7[§cOwner§7] ${getChatColor(player, 'nameTag') + "§4" + player.name}§7§l > §r${getChatColor(player, 'chatMessage') + "§c" + data.message.replace('§', '')}`, data.sender)
		} else if (!player.hasTag('OP')) {
			tellraw("@a", `§7[§8Player§7] ${getChatColor(player, 'nameTag') + "§7" + player.name}§7§l > §r${getChatColor(player, 'chatMessage') + "§f" + data.message.replace('§', '')}`, data.sender)
		}
	}
}
    })

    function getScore(player, obj) {
        try {
            return world.scoreboard.getObjective(obj).getScore(player.scoreboard)
        } catch (e) { return 0; }
    }

    function log(text) { runCommandAsync(`tellraw @a[tag=log] {"rawtext":[{"text":"§7{log} §r${text.replace(/"/g, "\'")}"}]}`) }

    log("§8[§4Staff Plugin§8] §7>> §aRun with succes !")
    runCommandAsync("scoreboard objectives add warn dummy")

    world.events.beforeItemUse.subscribe(event => {
        if (event.item.typeId === 'pf:adminstaff') {
            MenuAdmin(event.source)
        }
    })

function MenuAdmin(player) {
    if (player.hasTag('OP')) {
        let form = new ActionFormData()
        .title("§4Staff Menu")
        .body("")
        .button("§4Warn")
        .button("§4Unwarn")
		.button("§4Mute")
		.button("§4Unmute")
		.button("§4See Inventory")
		.button("§4Kick")
        .show(player).then(r => {
			 if (r.selection === 0) {
                warn(player)
            } else if (r.selection === 1) {
                unwarn(player)
            } else if (r.selection === 2) {
                mute(player)
            } else if (r.selection === 3) {
                unmute(player)
            } else if (r.selection === 4) {
				invspec(player)
			} else if (r.selection === 5) {
				kick(player)
			}
        })
    } else if (!player.hasTag('OP')) {
        player.tell("§cYou don't have permission to open this menu")
        player.runCommandAsync("playsound note.didgeridoo @s")
		player.runCommandAsync("clear @s compass 0 1")
		tellraw("@a[tag=OP]", `§c${player.name} §4trying to use the §cAdmin Staff §4§`)
    }
}

function kick(player) {
	let allPlayers = []
			allPlayers = [...world.getPlayers()]
			let buttonNumber
			var pg = new ActionFormData()
			pg.title("§4Who ?")
				allPlayers.forEach(function (element) {    //permet d'ouvrir un bouton par joueur
					if (isConnected(element)) {
						pg.button(element.name + '\n §8(§aOnline§8)')
						buttonNumber++
					}
				})
			pg.show(player).then(r => {//permet de tester le joueur selectionner par le bouton
			let name = allPlayers[r.selection]
			var tp = new ModalFormData()
			.title(`§4Kick §c${name.name}`)
			.textField("\n§aReason", " §r§oWrite here (optional)")
			.show(player).then(a => {
				    let raison = a.formValues[0]
				if (raison === "") {
					runCommandAsync(`kick "${name.name}" "§cYou have been kicked by §4${player.name}§c."`)
				} else {
					runCommandAsync(`kick "${name.name}" "§cYou have been kicked by §4${player.name}§c.\n§7Reason §f: §c${raison}"`)
				}
			})
		})
}

function mute(player) {
	let allPlayers = []
			allPlayers = [...world.getPlayers()]
			let buttonNumber
			var pg = new ActionFormData()
			pg.title("§4Who ?")
				allPlayers.forEach(function (element) {    //permet d'ouvrir un bouton par joueur
					if (isConnected(element)) {
						pg.button(element.name + '\n §8(§aOnline§8)')
						buttonNumber++
					}
				})
			pg.show(player).then(r => { //permet de tester le joueur selectionner par le bouton
			let name = allPlayers[r.selection]
			var tp = new ModalFormData()
			.title(`§4Mute §c${name.name}`)
			.textField("\n§aReason", " §r§oWrite here (optional)")
			.show(player).then(a => {
				    let raison = a.formValues[0]
				if (raison === "") {
					tellraw("@a", `§4[§7!§4] §c${name.name} §4has just been muted by §c${player.name}§4.`)
					runCommandAsync(`tag "${name.name}" add mute`)
				} else {
					tellraw("@a", `§4[§7!§4] §c${name.name} §4has just been muted by §c${player.name}§4.\n§7Reason §f: §a${raison}§7.`)
					runCommandAsync(`tag "${name.name}" add mute`)
				}
			})
		})
}

function unmute(player) {
	let allPlayers = []
			allPlayers = [...world.getPlayers()]
			let buttonNumber
			var pg = new ActionFormData()
			pg.title("§4Who ?")
				allPlayers.forEach(function (element) {    //permet d'ouvrir un bouton par joueur
					if (isConnected(element)) {
						pg.button(element.name + '\n §8(§aOnline§8)')
						buttonNumber++
					}
				})
			pg.show(player).then(r => { //permet de tester le joueur selectionner par le bouton
			let name = allPlayers[r.selection]
			var tp = new ModalFormData()
			.title(`§4Mute §c${name.name}`)
			.textField("\n§aReason", " §r§oWrite here (optional)")
			.show(player).then(a => {
				    let raison = a.formValues[0]
				if (raison === "") {
					if (name.hasTag('mute')) {
						tellraw("@a", `§4[§7!§4] §c${name.name} §4has just been unmuted by §c${player.name}§4.`)
						runCommandAsync(`tag "${name.name}" remove mute`)
					} else {
						player.tell(`§4[§7!§4] §c${name.name} §4was not mute.`)
						player.runCommandAsync("playsound note.didgeridoo @s")
					}
				} else {
					if (name.hasTag('mute')) {
						tellraw("@a", `§4[§7!§4] §c${name.name} §4has just been unmuted by §c${player.name}§4.§7Reason §f: §a${raison}§7.`)
						runCommandAsync(`tag "${name.name}" remove mute`)
					} else {
						player.tell(`§4[§7!§4] §c${name.name} §4was not mute.`)
						player.runCommandAsync("playsound note.didgeridoo @s")
					}
				}
			})
		})
}

function warn(player) {
	let warn = getScore(player, "warn")
	let allPlayers = []
			allPlayers = [...world.getPlayers()]
			let buttonNumber
			var pg = new ActionFormData()
			pg.title("§4Who ?")
				allPlayers.forEach(function (element) {    //permet d'ouvrir un bouton par joueur
					if (isConnected(element)) {
						pg.button(element.name + '\n §8(§aOnline§8)')
						buttonNumber++
					}
				})
			pg.show(player).then(r => { //permet de tester le joueur selectionner par le bouton
			let name = allPlayers[r.selection]
			var tp = new ModalFormData()
			.title(`§4Warn §c${name.name}`)
			.textField("\n§aReason", " §r§oWrite here (optional)")
			.show(player).then(a => {
				    let raison = a.formValues[0]
				if (raison === "") {
					tellraw("@a", `§4[§7!§4] §c${name.name} §4has just been warn by §c${player.name}§4.`)
					runCommandAsync(`scoreboard players add "${name.name}" warn 1`)
				} else {
					tellraw("@a", `§4[§7!§4] §c${name.name} §4has just been warn by §c${player.name}§4.\n§7Reason §f: §a${raison}§7.`)
					runCommandAsync(`scoreboard players add "${name.name}" warn 1`)
				}
			})
		})
}

function unwarn(player) {
	let warn = getScore(player, "warn")
	let allPlayers = []
			allPlayers = [...world.getPlayers()]
			let buttonNumber
			var pg = new ActionFormData()
			pg.title("§4Who ?")
				allPlayers.forEach(function (element) {    //permet d'ouvrir un bouton par joueur
					if (isConnected(element)) {
						pg.button(element.name + '\n §8(§aOnline§8)')
						buttonNumber++
					}
				})
			pg.show(player).then(r => { //permet de tester le joueur selectionner par le bouton
			let name = allPlayers[r.selection]
			var tp = new ModalFormData()
			.title(`§4Unwarn §c${name.name}`)
			.textField("\n§aReason", " §r§oWrite here (optional)")
			.show(player).then(a => {
				    let raison = a.formValues[0]
				if (raison === "") {
					tellraw("@a", `§4[§7!§4] §c${name.name} §4has just been unwarn by §c${player.name}§4.`)
					runCommandAsync(`scoreboard players remove "${name.name}" warn 1`)
					player.tell(`§4[§7!§4] §c${name.name} §4has just been unwarn by §c${player.name}§4.`)
				} else {
					tellraw("@a", `§4[§7!§4] §c${name.name} §4has just been unwarn by §c${player.name}§4.\n§7Reason §f: §a${raison}§7.`)
					runCommandAsync(`scoreboard players remove "${name.name}" warn 1`)
					player.tell(`§4[§7!§4] §c${name.name} §4has just been unwarn by §c${player.name}§4.\n§7Reason §f: §a${raison}§7.`)
				}
			})
		})
}

function isConnected(player) {
    let allPlayers = [];
    allPlayers = [...world.getPlayers()]
    if (allPlayers.includes(player)) return true
    else return false
}

function invspec(player) {
	let allPlayers = []
			allPlayers = [...world.getPlayers()]
			let buttonNumber
			var pg = new ActionFormData()
			pg.title("§7Who ?")
				allPlayers.forEach(function (element) {    //permet d'ouvrir un bouton par joueur
					if (isConnected(element)) {
						pg.button(element.name + '\n §8(§aOnline§8)')
						buttonNumber++
					}
				})
			pg.show(player).then(r => {
				let p = allPlayers[r.selection]
				let form = new ActionFormData()
				.title(`§l§4${p.name}'s Inventory :`)
				.body("")
					let container = p.getComponent("minecraft:inventory").container
						let o = []
						form.button("§4Hotbar :")
						for (let i = 0; i < 36; i++) {
							o.push(container.getItem(i) ?? { typeId: "§ominecraft:air", amount: 0, data: 0 })
						}
						o.forEach(i => {
							if (o.indexOf(i) == 9) {
								form.button("§4Inventory :")
							}
							form.button(`§r§4Slot ${o.indexOf(i) + 1}:\n§8 ${i.typeId}§c x${i.amount}§r`)
						})
						form.show(player).then(r => {
						})
			})
		}